Unit adh1e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, AFH1E_p;

procedure adh1e(var A :Array of Extended; var D1 :Extended;
                var D2 :Integer; var N :Integer; var IERR :Integer);
                
implementation

procedure adh1e(var A :Array of Extended; var D1 :Extended;
                var D2 :Integer; var N :Integer; var IERR :Integer);
var
K,I :Integer;
label
_2,_3,_1,_4,_5;
begin
AFH1E(A,N,IERR);
if ( IERR = 65 ) 
 then goto _5;
K := 0;
D1 := 1.e0;
D2 := 0;
for I:=1 to N do
 begin
  K := K+I;
  D1 := D1*A[K-1];
_2:
  if ( Abs(D1) < 1.e0 ) 
   then goto _3;
  D1 := D1*0.0625e0;
  D2 := D2+4;
  goto _2;
_3:
  if ( Abs(D1) >= 0.0625e0 ) 
   then goto _1;
  D1 := D1*16.e0;
  D2 := D2-4;
  goto _3;
_1:
 end;
D1 := D1*D1;
D2 := D2+D2;
_4:
if ( Abs(D1) >= 0.0625e0 ) 
 then goto _5;
D1 := D1*16.e0;
D2 := D2-4;
goto _4;
_5:
end;

end.
